//----------------------------------------------------------
// CREVBUF.H -- EAX Buffer Property Set Interface Class Definition
//
// Example code which makes it easy to use the EAX
// buffer property set interface
//
//----------------------------------------------------------

#ifndef CREVERBBUFFER_H_INCLUDED
#define CREVERBBUFFER_H_INCLUDED

#include <dsound.h>           // make sure DX5.0 SDK or above in path
#include <eax.h>

#define CREVERBBUFFER_SETGET (KSPROPERTY_SUPPORT_GET|KSPROPERTY_SUPPORT_SET)
#define CREVERBBUFFER_INVALID_VALUE -1.0E+30F

class CReverbBuffer
   {
   LPKSPROPERTYSET pPropertySet;        // pointer to property set interface

   int QueryProperty(unsigned long propertyId);   // Checks to see if a property is supported
public:
   CReverbBuffer(LPDIRECTSOUND3DBUFFER p3DBuf);    // Constructor
   int PropertySetOk();                           // Checks to see if interface is valid
   void SetReverbMix(float mix);        // Change the mix value
   void SetAll(EAXBUFFER_REVERBPROPERTIES *pProperties);   // Set all properties
   float GetReverbMix();                // Get the mix value
   void GetAll(EAXBUFFER_REVERBPROPERTIES *pProperties);   // Get all properties
   };

#endif
