//----------------------------------------------------------
// CREVERB.H -- EAX Property Set Interface Class Definition
//
// Example code which makes it easy to use the EAX
// property set interface
//
//----------------------------------------------------------

#ifndef CREVERB_H_INCLUDED
#define CREVERB_H_INCLUDED

#include <dsound.h>           // make sure DX5.0 SDK or above in path
#include <eax.h>

#define CREVERB_SETGET (KSPROPERTY_SUPPORT_GET|KSPROPERTY_SUPPORT_SET)
#define CREVERB_INVALID_VALUE -1.0E+30F

class CReverb
   {
protected:
   LPKSPROPERTYSET pPropertySet;        // pointer to property set interface

   int QueryProperty(unsigned long propertyId);   // Checks to see if a property is supported
public:
   CReverb(LPDIRECTSOUND3DBUFFER p3DBuf);     // Constructor
   int PropertySetOk();                           // Checks to see if interface is valid
   void SetEnvironment(unsigned long envId);      // Set a new environment
   void SetVolume(float volume);        // Change the volume
   void SetDecayTime(float time);       // Change the decay time
   void SetDamping(float damping);      // Change the damping
   void SetAll(EAX_REVERBPROPERTIES *pProperties);    // Set all properties
   void SetPreset(unsigned long envId, float volume, float time, float damping); // Set a preset
   unsigned long GetEnvironment();      // Get the current environment
   float GetVolume();                   // Get the volume
   float GetDecayTime();                // Get the decay time
   float GetDamping();                  // Get damping
   void GetAll(EAX_REVERBPROPERTIES *pProperties);    // Get all properties
   };

#endif
